<?php

function equation_callback($match) {
  $ret = new html2text(str_replace('\\', '\\\\', $match[0]));
  $ret = $ret->get_text();
  return $ret;
}

class htmlFilter {
  public static function filterText($text) {
#    $text = preg_replace('@\$\$([^\$\$]*)\$\$@', '<img src="http://s1.wordpress.com/latex.php?bg=ffffff&fg=000000&s=0&latex=$1" align="absmiddle"/>', $text);
     $text = preg_replace('@\$\$([^\$\$]*)\$\$@', '<img src="http://latex.codecogs.com/gif.latex?$1" align="absmiddle"/>', $text);
#    $text = str_replace(array('www.codecogs.com/gif.latex?', 'codecogs.izyba.com/gif.latex?'), 'www.forkosh.dreamhost.com/mathtex.cgi?', $text);
    return $text;
  }

  public static function preFilter($text) {
    $config = array(
           'indent'         => false,
           'clean'          => true,
#           'drop-proprietary-attributes'    =>    true,
           'output-xhtml'   => true,
           'fix-bad-comments'   => true,
           'hide-comments'   => true,
           'input-encoding' => 'utf8',
           'char-encoding' => 'utf8',
           'output-encoding' => 'utf8',
           'show-body-only' => true,
           'word-2000'   => false,
           'wrap'           => 0);
    //if (blogStore::$userId==1) {
    $tidy = tidy_repair_string($text, $config, 'utf8');
    //} else {
    //  $tidy = $text;
    //}
    $text = preg_replace_callback('@\$\$[^\$\$]*\$\$@', 'equation_callback', $tidy);
    sfLoader::loadHelpers('Helper');
    use_helper('Tag', 'Text');
    //$text = auto_link_text($text, 'all', '_blank');
    return $text;
  }

  /**
   * Enter description here...
   *
   * @param string $text
   * @return string validated text (empty string if cannot validate)
   */
  public static function validateHtml($text) {
  	$tidy = new tidy();
  	if ($tidy->parseString($text, array(
  		'input-encoding' => 'utf8',
      'output-encoding' => 'utf8'
  	))) {
			$content = '';
			foreach ($tidy->head()->child as $el) {
				if (@$el->name!='title') {
					$content .= $el->value;
				}
			}

			foreach ($tidy->body()->child as $el) {
				$content .= $el->value;
			}
  		return trim($content);
  	} else {
  		return '';
  	}
  }
}
